import { IItem,IListItem } from '@farmmaps/common';
import {Layer} from 'ol/layer';

export interface IItemLayer  {
  item: IItem,
  layer: Layer,
  visible: boolean,
  legendVisible:boolean,
  projection: string,
  opacity: number,
  layerIndex:number
}

export class ItemLayer implements IItemLayer {
  public item: IItem;
  public layer: Layer = null;
  public visible: boolean = true;
  public legendVisible: boolean = false;
  public projection: string;
  public opacity: number = 1;
  public layerIndex: number = -1;

  constructor(item:IItem) {
    this.item = item;
  }
}

export interface ITemporalItemLayer extends IItemLayer {
  previousLayer: Layer
  nextLayer: Layer
  temporalItems: IItem[],
  previousItem: IItem,
  selectedItem: IItem,
  nextItem:IItem
}

export class TemporalItemLayer extends ItemLayer implements ITemporalItemLayer {
  public previousLayer:Layer = null;
  public nextLayer:Layer = null;
  public temporalItems:IItem[] = [];
  public previousItem:IItem = null;
  public selectedItem:IItem =null;
  public nextItem:IItem = null;

  constructor(item:IItem) {
   super(item)
  }
}



